﻿-- ----------------------------------------------------------------------------
-- GridStatusTargetName by kunda
-- Updated by Cyprias (07/25/10)
-- ----------------------------------------------------------------------------
local folder, core = ...

local AceLibrary = AceLibrary
local UnitName = UnitName
local UnitExists = UnitExists
local UnitClass = UnitClass
local RAID_CLASS_COLORS = RAID_CLASS_COLORS
local tostring = tostring
local UnitGUID = UnitGUID

--~ local GridRoster = Grid:GetModule("GridRoster") --local RL --= AceLibrary("Roster-2.1")
--~ if not GridRoster then	error(folder .. " cannot find GridRoster.") return end
local L = AceLibrary("AceLocale-2.2"):new("GridStatusTargetName")

local GridStatusTargetName = Grid:GetModule("GridStatus"):NewModule("GridStatusTargetName") --GridStatusTargetName = GridStatus:NewModule("GridStatusTargetName")
GridStatusTargetName.menuName = L["Target Name"]

GridStatusTargetName.defaultDB = {
	debug = false,
	alert_targetname = {
		text =  L["Target Name"],
		enable = true,
		color = { r = 0.5, g = 0.5, b = 0.5, a = 1 },
		priority = 10,
		range = false,
	}
}

GridStatusTargetName.options = false

function GridStatusTargetName:OnInitialize()
	self.super.OnInitialize(self)
	self:RegisterStatus("alert_targetname", L["Target Name"], nil, true)
end

function GridStatusTargetName:OnEnable()
--~ 	if not GridRoster then
--~ 		RL = AceLibrary("Roster-2.1")
--~ 	end

	self:RegisterEvent("UNIT_TARGET")
--~ 	self:RegisterEvent("PARTY_MEMBERS_CHANGED")
end

function GridStatusTargetName:PARTY_MEMBERS_CHANGED()
	if not self.db.profile.alert_targetname.enable then return end
	
--~ 	if GridRoster then
--~ 		for guid, unitid in GridRoster:IterateRoster() do
--~ 			self:UNIT_TARGET(guid)
--~ 		end
--~ 	end
end

function GridStatusTargetName:UNIT_TARGET(unitID)
	local settings = self.db.profile.alert_targetname
	if not settings.enable then return end
	local unitname = UnitName(unitID)
	local targetID = unitID.."target"
	local guid = UnitGUID(unitID)
	if UnitExists(targetID) then
		local targetname = UnitName(targetID)
		
		local _, class = UnitClass(targetID)
		local color = RAID_CLASS_COLORS[class]
		if not color then 
			color = {r=.5,g=.5,b=.5}
		end

		
--~ 		if GridRoster then
--~ 			for guid, unitid in GridRoster:IterateRoster() do
--~ 				if UnitName(unitid) == unitname then
					self.core:SendStatusGained(guid, "alert_targetname",
						settings.priority,
						(settings.range and 40),
						{ r = color.r, g = color.g, b = color.b, a = settings.color.a },
						tostring(targetname)
					)
--~ 					break;
--~ 				end
--~ 			end
--~ 		end
	else
		self.core:SendStatusLost(guid, "alert_targetname")
	end
end
